class Circle extends Thing {

  Body body;
  float x, y, r;
  int drawColor;
  

  Circle(float _x, float _y, float _r, int _drawColor) {
    x = _x;
    y = _y;
    r = _r;
    drawColor = _drawColor;

    makeBody();    
  }

  void killBody() {
    box2d.destroyBody(body);
  }	

  // Drawing the box
  void display() {


    // We look at each body and get its screen position
    Vec2 pos = box2d.getScreenPos(body);
    // Get its angle of rotation
    float a = body.getAngle();


    pushMatrix();
    translate(pos.x,pos.y);
    rotate(-a);
    fill(drawColor);
    noStroke();
    ellipseMode(CENTER); // good idea?
    ellipse(0, 0, r * 2, r * 2);
    popMatrix();
  

  }

  void makeBody() {
    // Define a body
    BodyDef bd = new BodyDef();
    // Set its position
    bd.position = box2d.screenToWorld(x,y);
    body = box2d.world.createBody(bd);

    // Make the body's shape a circle
    CircleDef cd = new CircleDef();
    cd.radius = box2d.scaleScreenToWorld(r);
    cd.density = 1.0f;
    cd.friction = 0.3f;
    cd.restitution = 0.3f; // Restitution is bounciness
    body.createShape(cd);

    // Always do this at the end
    body.setMassFromShapes();
  }


}


