class Rectangle extends Thing {

  Body body;
  float x, y, w, h;
  int drawColor;

  Rectangle(float _x, float _y, float _w, float _h, int _drawColor) {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    drawColor = _drawColor;

    makeBody(new Vec2(x + w/2,y + h/2),w,h);    
  }

  void killBody() {
    box2d.destroyBody(body);
  }	

  // Drawing the box
  void display() {


    // We look at each body and get its screen position
    Vec2 pos = box2d.getScreenPos(body);
    // Get its angle of rotation
    float a = body.getAngle();

    rectMode(CENTER);
    pushMatrix();
    translate(pos.x,pos.y);
    rotate(-a);
    fill(drawColor);
    noStroke();
    rect(0,0,w,h);
    popMatrix();
rectMode(CORNER);    

  }

  void makeBody(Vec2 center, float w_, float h_) {
    // Define a polygon (this is what we use for a rectangle)
    PolygonDef sd = new PolygonDef();
    float box2dW = box2d.scaleScreenToWorld(w_/2);
    float box2dH = box2d.scaleScreenToWorld(h_/2);
    sd.setAsBox(box2dW, box2dH);

    // Parameters that affect physics
    sd.density = 1.0;
    sd.friction = 0.3;
    sd.restitution = 0.5;

    // Define the body and make it from the shape
    BodyDef bd = new BodyDef();
    bd.position.set(box2d.screenToWorld(center));

    body = box2d.createBody(bd);
    body.createShape(sd);
    body.setMassFromShapes();

    // Give it some initial random velocity
    //body.setLinearVelocity(new Vec2(random(-5,5),random(2,5)));
    //body.setAngularVelocity(random(-5,5));
  }


}


