import processing.core.*; 
import processing.xml.*; 

import pbox2d.*; 
import org.jbox2d.collision.shapes.*; 
import org.jbox2d.common.*; 
import org.jbox2d.dynamics.*; 
import org.jbox2d.collision.*; 
import org.jbox2d.dynamics.joints.*; 
import java.util.ListIterator; 
import java.util.LinkedList; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class noc_midterm extends PApplet {












// A reference to our box2d world
PBox2D box2d;


// A list we'll use to track fixed objects
ArrayList boundaries;
ArrayList buttons;
ArrayList things;
ColorPicker colorPicker;


Tool currentTool;




public void setup() {
  size(1024, 768);
  smooth();

  // Initialize box2d physics and create the world
  box2d = new PBox2D(this);
  box2d.createWorld();

  // Add some boundaries
  boundaries = new ArrayList();
  boundaries.add(new Boundary(100, 0, 924, 10));
  boundaries.add(new Boundary(100, 668, 924, 10));
  boundaries.add(new Boundary(100, 10, 10, 658));
  boundaries.add(new Boundary(1014, 10, 10, 658));

  // Add the tools
  RectangleTool rectangleTool = new RectangleTool(); // the rectangle tool creates rectangles
  CircleTool circleTool = new CircleTool();
  PencilTool pencilTool = new PencilTool();

  buttons = new ArrayList();
  buttons.add(new Button(0, 0, 100, 100, loadImage("rect-icon.png"), rectangleTool)); // this button activates the rectangle tool
  buttons.add(new Button(0, 100, 100, 100, loadImage("circle-icon.png"), circleTool));
  buttons.add(new Button(0, 200, 100, 100, loadImage("pencil-icon.png"), pencilTool));
  
  // Select the first button by defauls
  ((Button)buttons.get(0)).activate();

  colorPicker = new ColorPicker(0, 300, 100, 200);
  
  things = new ArrayList();
  

}

public void draw() {
  background(255);

  // We must always step through time!
  box2d.step();

  // Show the boundaries
  for (int i = 0; i < boundaries.size(); i++) {
    Boundary boundary = (Boundary) boundaries.get(i);
    boundary.display();
  }

  // Show the interface
  for (int i = 0; i < buttons.size(); i++) {
    Button button = (Button) buttons.get(i);
    button.display();
  }

  colorPicker.display();

  
  // Show the stuff on the stage
  for (int i = 0; i < things.size(); i++) {
    Thing thing = (Thing) things.get(i);
    thing.display();
  }  

  currentTool.display();

  // 
  // // Here we create a dynamic gravity vector based on the location of our mouse
  // PVector g = new PVector(mouseX-width/2,mouseY-height/2);
  // g.normalize();
  // g.mult(10);
  // box2d.setGravity(g.x, -g.y);

}

public void mousePressed() {
  // use the tool...
  if((mouseX > 110 && mouseX < 1024) && (mouseY > 10 && mouseY < 668)) {
    println("down on stage");
    currentTool.onStart();
  }
}

public void mouseDragged() {
  if(currentTool.drawing) {
    currentTool.onDrag();
  }
}



public void mouseReleased() {
  if((mouseX > 110 && mouseX < 1024) && (mouseY > 10 && mouseY < 668)) {
    println("up on stage");
    currentTool.onFinish();
  }
  else {
    currentTool.onCancel();
  }
}

// class Border {
//   ArrayList perimeter;
// 
//   Border() {
//     perimeter = new ArrayList();
// 
//     // This is what box2d uses to put the surface in its world
//     EdgeChainDef edges = new EdgeChainDef();
// 
// 
//     // This has to go backwards so that the objects  bounce off the top of the surface
//     // This "edgechain" will only work in one direction!
//     for (float x = width+10; x > -10; x -= 5) {
// 
//       // The edge point in our window
//       Vec2 screenEdge = new Vec2(x,y);
//       // We store it for rendering
//       perimeter.add(screenEdge);
// 
//       // Convert it to the box2d world and add it to our EdgeChainDef
//       Vec2 edge = box2d.screenToWorld(screenEdge);
//       edges.addVertex(edge);
// 
//       // Move through perlin noise
// 
// 
//     }
//     edges.setIsLoop(true);   // We could make the edge a full loop
//     edges.friction = 2.0;    // How much friction
//     edges.restitution = 0.3; // How bouncy
// 
//     // The edge chain is now a body!
//     BodyDef bd = new BodyDef();
//     bd.position.set(0.0f,0.0f);
//     Body body = box2d.world.createBody(bd);
//     body.createShape(edges);
//   }
// 
//   // A simple function to just draw the edge chain as a series of vertex points
//   void display() {
//     strokeWeight(2);
//     stroke(0);
//     noFill();
//     beginShape();
//     for (int i = 0; i < surface.size(); i++) {
//       Vec2 v = (Vec2) surface.get(i);
//       vertex(v.x,v.y);
//     }
//     endShape();
//   }
// 
// }
// 
class Boundary {
  float x, y, w, h;
  Body b;

  Boundary(float x_,float y_, float w_, float h_) {
    x = x_;
    y = y_;
    w = w_;
    h = h_;

    // Figure out the box2d coordinates
    float box2dW = box2d.scaleScreenToWorld(w);
    float box2dH = box2d.scaleScreenToWorld(h);
    Vec2 position = new Vec2(x,y);

    // Define the polygon
    PolygonDef sd = new PolygonDef();
    sd.setAsBox(box2dW, box2dH);
    sd.density = 0;    // No density means it won't move!
    sd.friction = 0.3f;

    // Create the body
    BodyDef bd = new BodyDef();
    bd.position.set(box2d.screenToWorld(position));
    b = box2d.createBody(bd);
    b.createShape(sd);
    
    if(y > 100) y -= 10; // weird thickness issue
  }

  // Draw the boundary, if it were at an angle we'd have to do something fancier
  public void display() {
    fill(0);
    stroke(0);

    rect(x,y,w,h);
  }

}


// basic interface element, when clicked it selects the currently active tool
class Button {
  float x, y, w, h;
  int basicColor, activeColor;
  int state = 0;
  boolean active = false;
  Tool tool;
  PImage icon;


  Button(float _x, float _y, float _w, float _h, PImage _icon, Tool _tool) {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    tool = _tool;
    basicColor = color(100, 0, 0); 
    activeColor = color(255, 0, 0);
    println(tool);
    icon = _icon;
  }


  public void display() {

    // check for state

    if((mouseX > x && mouseX < x + w) && (mouseY > y && mouseY < y + h))  {
      // must be over
      if(mousePressed == true) {
        // must have clicked
        activate();
      }
    }


    noStroke();

    if(active) {
      fill(colorPicker.currentColor);
    }
    else {
      fill(colorPicker.currentColor, 100);
    } 

    rect(x, y, w, h);
    image(icon, x, y);
  }

  public void activate() {
    // deactivate other buttons
    for (int i = 0; i < buttons.size(); i++) {
      Button button = (Button) buttons.get(i);
      button.deactivate();
    }    
    
    active = true;
    currentTool = tool;
    println("current tool is " + currentTool);   
  }

  public void deactivate() {
    active = false;
  }


}


class Circle extends Thing {

  Body body;
  float x, y, r;
  int drawColor;
  

  Circle(float _x, float _y, float _r, int _drawColor) {
    x = _x;
    y = _y;
    r = _r;
    drawColor = _drawColor;

    makeBody();    
  }

  public void killBody() {
    box2d.destroyBody(body);
  }	

  // Drawing the box
  public void display() {


    // We look at each body and get its screen position
    Vec2 pos = box2d.getScreenPos(body);
    // Get its angle of rotation
    float a = body.getAngle();


    pushMatrix();
    translate(pos.x,pos.y);
    rotate(-a);
    fill(drawColor);
    noStroke();
    ellipseMode(CENTER); // good idea?
    ellipse(0, 0, r * 2, r * 2);
    popMatrix();
  

  }

  public void makeBody() {
    // Define a body
    BodyDef bd = new BodyDef();
    // Set its position
    bd.position = box2d.screenToWorld(x,y);
    body = box2d.world.createBody(bd);

    // Make the body's shape a circle
    CircleDef cd = new CircleDef();
    cd.radius = box2d.scaleScreenToWorld(r);
    cd.density = 1.0f;
    cd.friction = 0.3f;
    cd.restitution = 0.3f; // Restitution is bounciness
    body.createShape(cd);

    // Always do this at the end
    body.setMassFromShapes();
  }


}


// abstract class for a tool... responds to dragging and releasing on the stage. Tools generate things.
class CircleTool extends Tool {
  CircleTool () {
    super();
  }
  
  
  
  
  public void display() {
    if(drawing) {
      // better to create the output thing and draw in preview mode?
      noFill();
      strokeWeight(3);
      stroke(colorPicker.currentColor);
      ellipseMode(CENTER);
      
    float x = min(startX, mouseX);
    float y = min(startY, mouseY);
    float rx = max(startX, mouseX) - x;
    float ry = max(startY, mouseY) - y;  
      
      ellipse(startX, startY,max(rx, ry) * 2, max(rx, ry) * 2);
    }
  }
  
  public void onFinish() {
    super.onFinish();

    // sounds good, let's add a rectangle to the stage
    float x = min(startX, mouseX);
    float y = min(startY, mouseY);
    float rx = max(startX, mouseX) - x;
    float ry = max(startY, mouseY) - y;    

    
    things.add(new Circle(x, y, max(rx, ry), colorPicker.currentColor));
  }  
  


}
class ColorPicker {
  float x, y, w, h;
  PImage palette;
  int currentColor;
  
  ColorPicker(float _x, float _y, float _w, float _h) {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    palette = createImage((int)w, (int)h, RGB);
    palette.loadPixels();
    
    
    colorMode(HSB);
    for (int i = 0; i < w; i++) {
      for (int j = 0; j < h; j++) {
        palette.set(i, j, color(map(i, 0, w, 0, 255), 255, map(j, 0, h, 0, 255)));
      }
    }
    colorMode(RGB);
    
    // generate the colors
    
    palette.updatePixels();
  }
  
  public void display() {
    image(palette, x, y);
    
    // picke a color
     if((mouseX > x && mouseX < x + w) && (mouseY > y && mouseY < y + h))  {
       // must be over
       if(mousePressed == true) {
         // must have clicked
         // update the color
         currentColor = palette.get(mouseX - (int)x, mouseY - (int)y);
         println(currentColor);
       }
     }   
    
  }
  
}
class Line extends Thing {

  int drawColor;
  Body body;
  float strokeWidth;   

  Line(ArrayList sourcePoints, int _drawColor) {
    drawColor = _drawColor;
    println("creating line");
    println(sourcePoints);


    strokeWidth = .2f;

    BodyDef bd = new BodyDef();
    bd.isBullet = true;
    body = box2d.world.createBody(bd); // should be dynamic body?


    for (int i = 0; i < sourcePoints.size() - 1; ++i) {
      PolygonDef sd = new PolygonDef();
      sd.density = 2.0f;
      sd.friction = 0.3f;
      // need to go screen to world?
      Vec2 thisPoint = (Vec2)sourcePoints.get(i);
      Vec2 nextPoint = (Vec2)sourcePoints.get(i + 1);      
      
      createStrokeRect(thisPoint, nextPoint,strokeWidth,body,sd);
    }

    body.setMassFromShapes();    

    
    


  }

  public void display() {
    Vec2 pos = box2d.getScreenPos(body);

     pushMatrix();
    //translate(pos.x, pos.y);
    float a = body.getAngle();
    //rotate(-a);    
     

 	for (org.jbox2d.collision.shapes.Shape s = body.getShapeList(); s != null; s = s.getNext()) {
          PolygonShape tempShape = (PolygonShape)s;
   
          println(s);
          
          //noFill();
          fill(drawColor);
          stroke(drawColor);
          strokeWeight(1);
          beginShape();
          Vec2[] vertices = tempShape.getVertices();
          for(int i = 0; i < tempShape.getVertexCount(); i++) {
            Vec2 thisPoint =  box2d.worldToScreen(vertices[i]);
            //thisPoint = vertices[i];
            vertex(thisPoint.x, thisPoint.y);
          
          }
          endShape(CLOSE);
          
          
       }

     
     popMatrix();






  }





  public void createStrokeRect(Vec2 start, Vec2 end, float radius, Body body, PolygonDef sd) {
    //The shape count check appears unimportant 
    //if (body.m_shapeCount >= Settings.maxShapesPerBody) return;
    Vec2 tangent = end.sub(start); //not normalized
    Vec2 perp = new Vec2(tangent.y,-tangent.x);
    perp.normalize();
    perp.mulLocal(radius);
    sd.vertices.add(start.add(perp));
    sd.vertices.add(end.add(perp));
    sd.vertices.add(end.sub(perp));
    sd.vertices.add(start.sub(perp));
    body.createShape(sd);
  }  

}








class PencilTool extends Tool {
  // adapted from the PBox2D ShapeDrawing.java example

  ArrayList mousePoints;
  int mouseStrokeLength;

  PencilTool() {
    super();
    mousePoints = new ArrayList();
    mouseStrokeLength = 0;
  }

  public void display() {
    if(drawing) {
      stroke(colorPicker.currentColor);
      strokeWeight(3);
      noFill();
      beginShape();
      for(int i = 0; i < mousePoints.size(); i++) {
        Vec2 mousePoint = (Vec2)mousePoints.get(i);
        mousePoint = box2d.worldToScreen(mousePoint);
        vertex(mousePoint.x, mousePoint.y);
      }
      endShape();
    }

  }

  public void onStart() {
    super.onStart();
    mousePoints = new ArrayList();    
    addMousePoint();
  }


  public void onDrag() {
    println("drag");
    addMousePoint();
  }

  public void onFinish() {
    super.onFinish();
    
    // spawn a line
    
    things.add(new Line(mousePoints, colorPicker.currentColor));    
    
    
    
    mousePoints = new ArrayList(); 
  }   
  
  public void onCancel() {
    super.onCancel();
    mousePoints = new ArrayList();  
  }


  public void addMousePoint() {
    mousePoints.add(box2d.screenToWorld(new Vec2(mouseX, mouseY)));
  }

}




class Rectangle extends Thing {

  Body body;
  float x, y, w, h;
  int drawColor;

  Rectangle(float _x, float _y, float _w, float _h, int _drawColor) {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    drawColor = _drawColor;

    makeBody(new Vec2(x + w/2,y + h/2),w,h);    
  }

  public void killBody() {
    box2d.destroyBody(body);
  }	

  // Drawing the box
  public void display() {


    // We look at each body and get its screen position
    Vec2 pos = box2d.getScreenPos(body);
    // Get its angle of rotation
    float a = body.getAngle();

    rectMode(CENTER);
    pushMatrix();
    translate(pos.x,pos.y);
    rotate(-a);
    fill(drawColor);
    noStroke();
    rect(0,0,w,h);
    popMatrix();
rectMode(CORNER);    

  }

  public void makeBody(Vec2 center, float w_, float h_) {
    // Define a polygon (this is what we use for a rectangle)
    PolygonDef sd = new PolygonDef();
    float box2dW = box2d.scaleScreenToWorld(w_/2);
    float box2dH = box2d.scaleScreenToWorld(h_/2);
    sd.setAsBox(box2dW, box2dH);

    // Parameters that affect physics
    sd.density = 1.0f;
    sd.friction = 0.3f;
    sd.restitution = 0.5f;

    // Define the body and make it from the shape
    BodyDef bd = new BodyDef();
    bd.position.set(box2d.screenToWorld(center));

    body = box2d.createBody(bd);
    body.createShape(sd);
    body.setMassFromShapes();

    // Give it some initial random velocity
    //body.setLinearVelocity(new Vec2(random(-5,5),random(2,5)));
    //body.setAngularVelocity(random(-5,5));
  }


}


// 
class RectangleTool extends Tool {

  RectangleTool() {
    super();
  }

  public void display() {
    if(drawing) {
      // better to create the output thing and draw in preview mode?
      noFill();
      strokeWeight(3);
      stroke(colorPicker.currentColor);
      rect(startX, startY, mouseX - startX, mouseY - startY);
    }
  }

  public void onFinish() {
    super.onFinish();

    // sounds good, let's add a rectangle to the stage
    float x = min(startX, mouseX);
    float y = min(startY, mouseY);
    float w = max(startX, mouseX) - x;
    float h = max(startY, mouseY) - y;
    
    things.add(new Rectangle(x, y, w, h, colorPicker.currentColor));
  }


}

// abstract class for a graphic element on the stage, updated every tick
class Thing {
  
  
  Thing() {
  }
  
  public void display() {
  }

}

// abstract class for a tool... responds to dragging and releasing on the stage. Tools generate things.
class Tool {
  boolean drawing;
  int startX, startY;
  
  Tool() {
    drawing = false;
  }
  
  public void onStart() {
    drawing = true;
    startX = mouseX;
    startY = mouseY;
  }

  public void onDrag() {
  }
  
  public void onFinish() {
    drawing = false;
    println("finish");
  }
  
  public void onCancel() {
    drawing = false;
  }
  
  public void display() {
  }

}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "noc_midterm" });
  }
}
