// basic interface element, when clicked it selects the currently active tool
class Button {
  float x, y, w, h;
  int basicColor, activeColor;
  int state = 0;
  boolean active = false;
  Tool tool;
  PImage icon;


  Button(float _x, float _y, float _w, float _h, PImage _icon, Tool _tool) {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    tool = _tool;
    basicColor = color(100, 0, 0); 
    activeColor = color(255, 0, 0);
    println(tool);
    icon = _icon;
  }


  void display() {

    // check for state

    if((mouseX > x && mouseX < x + w) && (mouseY > y && mouseY < y + h))  {
      // must be over
      if(mousePressed == true) {
        // must have clicked
        activate();
      }
    }


    noStroke();

    if(active) {
      fill(colorPicker.currentColor);
    }
    else {
      fill(colorPicker.currentColor, 100);
    } 

    rect(x, y, w, h);
    image(icon, x, y);
  }

  void activate() {
    // deactivate other buttons
    for (int i = 0; i < buttons.size(); i++) {
      Button button = (Button) buttons.get(i);
      button.deactivate();
    }    
    
    active = true;
    currentTool = tool;
    println("current tool is " + currentTool);   
  }

  void deactivate() {
    active = false;
  }


}


