class Line extends Thing {

  int drawColor;
  Body body;
  float strokeWidth;   

  Line(ArrayList sourcePoints, int _drawColor) {
    drawColor = _drawColor;
    println("creating line");
    println(sourcePoints);


    strokeWidth = .2f;

    BodyDef bd = new BodyDef();
    bd.isBullet = true;
    body = box2d.world.createBody(bd); // should be dynamic body?


    for (int i = 0; i < sourcePoints.size() - 1; ++i) {
      PolygonDef sd = new PolygonDef();
      sd.density = 2.0f;
      sd.friction = 0.3f;
      // need to go screen to world?
      Vec2 thisPoint = (Vec2)sourcePoints.get(i);
      Vec2 nextPoint = (Vec2)sourcePoints.get(i + 1);      
      
      createStrokeRect(thisPoint, nextPoint,strokeWidth,body,sd);
    }

    body.setMassFromShapes();    

    
    


  }

  void display() {
    Vec2 pos = box2d.getScreenPos(body);

     pushMatrix();
    //translate(pos.x, pos.y);
    float a = body.getAngle();
    //rotate(-a);    
     

 	for (org.jbox2d.collision.shapes.Shape s = body.getShapeList(); s != null; s = s.getNext()) {
          PolygonShape tempShape = (PolygonShape)s;
   
          println(s);
          
          //noFill();
          fill(drawColor);
          stroke(drawColor);
          strokeWeight(1);
          beginShape();
          Vec2[] vertices = tempShape.getVertices();
          for(int i = 0; i < tempShape.getVertexCount(); i++) {
            Vec2 thisPoint =  box2d.worldToScreen(vertices[i]);
            //thisPoint = vertices[i];
            vertex(thisPoint.x, thisPoint.y);
          
          }
          endShape(CLOSE);
          
          
       }

     
     popMatrix();






  }





  void createStrokeRect(Vec2 start, Vec2 end, float radius, Body body, PolygonDef sd) {
    //The shape count check appears unimportant 
    //if (body.m_shapeCount >= Settings.maxShapesPerBody) return;
    Vec2 tangent = end.sub(start); //not normalized
    Vec2 perp = new Vec2(tangent.y,-tangent.x);
    perp.normalize();
    perp.mulLocal(radius);
    sd.vertices.add(start.add(perp));
    sd.vertices.add(end.add(perp));
    sd.vertices.add(end.sub(perp));
    sd.vertices.add(start.sub(perp));
    body.createShape(sd);
  }  

}






