
class PencilTool extends Tool {
  // adapted from the PBox2D ShapeDrawing.java example

  ArrayList mousePoints;
  int mouseStrokeLength;

  PencilTool() {
    super();
    mousePoints = new ArrayList();
    mouseStrokeLength = 0;
  }

  void display() {
    if(drawing) {
      stroke(colorPicker.currentColor);
      strokeWeight(3);
      noFill();
      beginShape();
      for(int i = 0; i < mousePoints.size(); i++) {
        Vec2 mousePoint = (Vec2)mousePoints.get(i);
        mousePoint = box2d.worldToScreen(mousePoint);
        vertex(mousePoint.x, mousePoint.y);
      }
      endShape();
    }

  }

  void onStart() {
    super.onStart();
    mousePoints = new ArrayList();    
    addMousePoint();
  }


  void onDrag() {
    println("drag");
    addMousePoint();
  }

  void onFinish() {
    super.onFinish();
    
    // spawn a line
    
    things.add(new Line(mousePoints, colorPicker.currentColor));    
    
    
    
    mousePoints = new ArrayList(); 
  }   
  
  void onCancel() {
    super.onCancel();
    mousePoints = new ArrayList();  
  }


  void addMousePoint() {
    mousePoints.add(box2d.screenToWorld(new Vec2(mouseX, mouseY)));
  }

}




